;; $Id: generic.lisp,v 1.14 2005/05/23 21:11:35 jimka Exp $

#|

 This software is Copyright (c) 2005 Jim Newton <jimka@rdrop.com>

 Jim Newton grants you the rights to distribute
 and use this software as governed by the terms
 of the Lisp Lesser GNU Public License
 (http://opensource.franz.com/preamble.html),
 known as the LLGPL.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
|#

(in-package blocker)

(defgeneric -symbol ( ignored) )
(defgeneric handle-event ( self  ev) )
(defgeneric all-combinations ( x y) )
(defgeneric apply-combination ( state blocker opponent combination partial &key verbose) )
(defgeneric comb-contains-diagonal ( combination ) )
(defgeneric deltax ( ignored) )
(defgeneric deltay ( ignored) )
(defgeneric diagonal-p ( ignored) )
(defgeneric do-pending-events ( self) )
(defgeneric draw-grid ( self) )
(defgeneric duplicate ( self) )
(defgeneric effective-combination ( self) )
(defgeneric find-event-by-shortcut ( game shortcut) )
(defgeneric get-occupants ( square) )
(defgeneric get-squares ( new-state) )
(defgeneric ident-p ( ignored) )
(defgeneric initial-placement ( player) )
(defgeneric inverse-p ( ignore1 ignore2) )
(defgeneric looser-p ( player ) )
(defgeneric num-cols ( ignored) )
(defgeneric num-rows ( ignored) )
(defgeneric apply-round (obj))
(defgeneric other-turn ( event ) )
(defgeneric pieces ( player) )
(defgeneric qpop ( q) )
(defgeneric printable ( ignored) )
(defgeneric put-event ( game event) )
(defgeneric redundant-p ( self) )
(defgeneric roll ( dir new-state) )
(defgeneric select-event ( self) )
(defgeneric update ( board piece) )
(defgeneric valid-intermediate-state ( new-state opponent) )
(defgeneric winner-p ( player &key verbose) )
(defgeneric legal-p ( self) )
(defgeneric any-valid-move ( self) )
(defgeneric is-check ( self) )
(defgeneric leaves-in-check ( piece comb) )
(defgeneric calc-best-move ( self) )
(defgeneric move-piece ( self comb) )
(defgeneric predict-state ( self comb) )
(defgeneric unmove ( self comb) )
(defgeneric is-valid-comb ( player piece comb &key verbose) )
(defgeneric choose-movable ( self) )
(defgeneric move-player ( player) )
(defgeneric auto-play ( self))
(defgeneric pick-up ( piece))
(defgeneric save-history ( self))
(defgeneric deselect-piece ( player ))
(defgeneric init-selected-combination ( turn))
(defgeneric GET-SELECTED-COMBINATION ( turn))
(defgeneric GET-SELECTED-PIECE ( turn))
(defgeneric calc-position-rating ( self))
(defgeneric is-legal-direction ( piece dir comb))
(defgeneric write-output (self string))
(defgeneric select-piece ( player piece))
(defgeneric remember-direction ( player dir))
(defgeneric move-generic ( dir piece parity))
(defgeneric inverse ( dir))
(defgeneric read-input (self))
(defgeneric -read-from-file ( self))
(defgeneric -write-to-file ( self))
(defgeneric shadow-size ( self))
(defgeneric wasted-shaodw ( self))
(defgeneric get-shadow ( self))
(defgeneric closeness-to-backline ( self ))
(defgeneric sweep-directions ( self))
(defgeneric approach-direction ( self piece))
(defgeneric angle ( self ))

(defgeneric x-coord ( self))
(defgeneric y-coord ( self))
(defgeneric z-coord ( self))
(defgeneric events ( self))

(defgeneric pt-to-canvas ( gui pt))
(defgeneric initialize-board ( gui))
(defgeneric tk-color ( gui color))
(defgeneric tk-faces ( gui))
(defgeneric tk-select-event (piece dir))
(defgeneric tk-becomes (player))
(defgeneric tk-bind-face (gui face piece))
(defgeneric (setf events) (new-value obj))
(defgeneric (setf oponent) (new-value obj))
(defgeneric (setf players) (new-value obj))
(defgeneric (setf x-coord) (new-value obj))
(defgeneric (setf y-coord) (new-value obj))
(defgeneric (setf z-coord) (new-value obj))

(defgeneric correlate-faces ( face1 face2))
(defgeneric mid-point ( obj1 obj2))

			      
(defgeneric show-combinations ( self))
(defgeneric get-state-key ( self))
(defgeneric choose-comb-from-effective (piece key))
(defgeneric game-over (self))
(defgeneric strat-to-hash (obj))
(defgeneric hash-to-strat (obj hash))
(defgeneric white (obj))
(defgeneric black (obj))
(defgeneric swap-strategies (obj))


(defgeneric any-valid-comb (self))
(defgeneric reduce-combination (piece comb ))
(defgeneric get-shadow-and-wasted-shadow ( player))
(defgeneric apply-translate (self &key dx dy))
(defgeneric apply-rotate (pt mat))
(defgeneric apply-transform ( pt matrix))

(defgeneric vec-direction ( self dx dy))
;;(defgeneric get-square ( board &key row col))
(defgeneric calc-combinations (self))
(defgeneric empty-p (q))
(defgeneric prompt (self))
(defgeneric qpush (q item))
(defgeneric blocker (obj))
(defgeneric create-colored-polygon (gui face))
(defgeneric VISUAL-GAME (BLO ))
(defgeneric SORT-PIECES (GUI ))
(defgeneric SCROLL-TO-VIEW (GUI ))
(defgeneric UPDATE-BOARD (GUI ))
(defgeneric DRAW-FACE (GUI FACE ))
(defgeneric CALC-DIR-BOUND (DIR PHD ))
(defgeneric CALC-EXTREME (PHD COORD-FUN EXTREME-FUN ))
(defgeneric POLY-ROLL (PHD X-BOUND Y-BOUND MAT ))
(defgeneric MAKE-POLYHEDRAN (STATE COLOR ))
(defgeneric MAKE-SPECIFIC-POLYHEDRAN (COLOR X Y DX DY DZ ))
(defgeneric MAKE-FACES (CLASS COLOR POINT-LISTS ))
(defgeneric FACE-CLASS (FC ))
(defgeneric MATRIX-MULTIPLY (MAT1 MAT2 &REST MATRICES ))
(defgeneric MATRIX-MULTIPLY-2 (SELF OTHER ))
(defgeneric SET-MATRIX (MAT VALUE &KEY ROW COL ))
(defgeneric ADD-POINT (PT1 PT2 ))
(defgeneric SCALE-POINT (PT SCALE ))
(defgeneric CMP-PIECES (SELF PIECE1 PIECE2 ))
(defgeneric FILE-NAME (SELF ))
(defgeneric RATING (SELF ))
(defgeneric COMPONENT-VALUE (SELF ))
(defgeneric PLAYER (SELF ))
(defgeneric COUNTERCLOCKWISE (SELF ))
(defgeneric CLOCKWISE (SELF ))
(defgeneric COMPUTER-BECOMES (SELF ))
(defgeneric WASTED-SHADOW (PLAYER ))
(defgeneric SELECTED-COMBINATION (PLAYER ))
(defgeneric FIND-PIECE (SELF VOLUME ))
(defgeneric PRINT-RATED (PM RATING ))
(defgeneric PRINT-SHADOW (SELF ))
(defgeneric IS-VALID-SQUARE (SELF &KEY ROW COL ))
(defgeneric GET-OCCUPANT (SELF &KEY ROW COL ))
(defgeneric OCCUPANT (SELF ))
(defgeneric OCCUPY (SELF ROW COL PIECE ))
(defgeneric DIVIDE-ROWS (SELF ROW1 ROW2 ))
(defgeneric DRAW-ROW (SELF Y ))
(defgeneric DRAW-COL-NUMS (SELF ))
(defgeneric DRAW (SELF ))
(defgeneric FIND-PLAYER (SELF SYMBOL ))
(defgeneric DO-EVENT (GAME EVENT ))
(defgeneric REMEMBER-MOVE (GAME DIRECTION PIECE ))
(defgeneric FORGET-MOVE (GAME ))
(defgeneric UNDO-MOVE (SELF ))
(defgeneric UNDO-COMBINATION (SELF ))
(defgeneric GET-EVENT-FROM-QUEUE (SELF ))
(defgeneric DISPATCH-EVENT (SELF EV ))
(defgeneric DO-ONE-EVENT (SELF ))
(defgeneric PLAY (SELF ))
(defgeneric WINNER-OF-GAME (SELF &KEY VERBOSE ))
(defgeneric PRINT-CHECK-MATE (SELF PLAYER-IN-CHECK ))
(defgeneric FIND-DIRECTION (SELF SYMBOL ))
(defgeneric IS-CHECK-MATE (SELF IN-CHECK-P ))
(defgeneric MOVE-AUTOMATIC (SELF ))
(defgeneric MOVE-INTERACTIVE (SELF ))

(defgeneric COMB-TO-LIST (SELF ))
(defgeneric EQUIV-COMBINATIONS (COMB1 COMB2 ))
(defgeneric COMB-EXPAND-DIAG (LIST-OF-DIRS ))
(defgeneric REDUCE-PIECE-MOVE (SELF ))
(defgeneric SHORTHAND (SELF ))
(defgeneric XRANGE (SELF ))
(defgeneric SIZE (SELF ))
(defgeneric NEW-OUTPUT (SELF FP ))
(defgeneric FORGET-OUTPUT (SELF FP ))
(defgeneric ELEMENTS (Q ))
(defgeneric QFLUSH (Q ))
(defgeneric GODFATHER-P (IGNORED ))
(defgeneric CALC-CANONICAL-COMB-KEY (PIECE COMB ))
(defgeneric CALC-EFFECTIVE-COMBINATIONS (PIECE ))
(defgeneric DOES-COMB-ATTACK (SELF DEFENDER COMB ))
(defgeneric CHOOSE-DIRECTION (PIECE HISTORY I ))
(defgeneric PLACE-PIECE (SELF &KEY X Y DX DY ))
(defgeneric IS-ATTACKING (ATTACKER DEFENDER ))
(defgeneric MATCHES-FIRST-N (PARTIAL-LIST1 LIST2 ))
(defgeneric FIND-MATCHING-COMBINATIONS (SELF PARTIAL-TARGET-COMB ))
(defgeneric DIST (PT FACE ))
(defgeneric CENTER (TK-FACE ))
(defgeneric SHOW-BASIC-COMBINATIONS (PIECE ))
(defgeneric SHOW-EFF-COMBINATIONS (PIECE ))
(defgeneric LEN (SELF ))
(defgeneric ADD-HISTORY (ENTRY TXT ))
(defgeneric CLEAR-HISTORY (ENTRY ))
(defgeneric event-setup (eh))

